/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the YoutubeAnalyticsControllerActionChannelRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &YoutubeAnalyticsControllerActionChannelRequest{}

// YoutubeAnalyticsControllerActionChannelRequest struct for YoutubeAnalyticsControllerActionChannelRequest
type YoutubeAnalyticsControllerActionChannelRequest struct {
	OAuthId *string `json:"oAuthId,omitempty"`
}

// NewYoutubeAnalyticsControllerActionChannelRequest instantiates a new YoutubeAnalyticsControllerActionChannelRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewYoutubeAnalyticsControllerActionChannelRequest() *YoutubeAnalyticsControllerActionChannelRequest {
	this := YoutubeAnalyticsControllerActionChannelRequest{}
	return &this
}

// NewYoutubeAnalyticsControllerActionChannelRequestWithDefaults instantiates a new YoutubeAnalyticsControllerActionChannelRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewYoutubeAnalyticsControllerActionChannelRequestWithDefaults() *YoutubeAnalyticsControllerActionChannelRequest {
	this := YoutubeAnalyticsControllerActionChannelRequest{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *YoutubeAnalyticsControllerActionChannelRequest) GetOAuthId() string {
	if o == nil || IsNil(o.OAuthId) {
		var ret string
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *YoutubeAnalyticsControllerActionChannelRequest) GetOAuthIdOk() (*string, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *YoutubeAnalyticsControllerActionChannelRequest) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given string and assigns it to the OAuthId field.
func (o *YoutubeAnalyticsControllerActionChannelRequest) SetOAuthId(v string) {
	o.OAuthId = &v
}

func (o YoutubeAnalyticsControllerActionChannelRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o YoutubeAnalyticsControllerActionChannelRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	return toSerialize, nil
}

type NullableYoutubeAnalyticsControllerActionChannelRequest struct {
	value *YoutubeAnalyticsControllerActionChannelRequest
	isSet bool
}

func (v NullableYoutubeAnalyticsControllerActionChannelRequest) Get() *YoutubeAnalyticsControllerActionChannelRequest {
	return v.value
}

func (v *NullableYoutubeAnalyticsControllerActionChannelRequest) Set(val *YoutubeAnalyticsControllerActionChannelRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableYoutubeAnalyticsControllerActionChannelRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableYoutubeAnalyticsControllerActionChannelRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableYoutubeAnalyticsControllerActionChannelRequest(val *YoutubeAnalyticsControllerActionChannelRequest) *NullableYoutubeAnalyticsControllerActionChannelRequest {
	return &NullableYoutubeAnalyticsControllerActionChannelRequest{value: val, isSet: true}
}

func (v NullableYoutubeAnalyticsControllerActionChannelRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableYoutubeAnalyticsControllerActionChannelRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
